STROKES = 27
LETTER = {
	'a' => [0],
	'b' => [1],
	'c' => [2],
	'd' => [3],
	'e' => [4],
	'f' => [5],
	'g' => [6],
	'h' => [7],
	'i' => [8],
	'j' => [9],
	'k' => [8,10],
	'l' => [11],
	'm' => [12],
	'n' => [13],
	'o' => [14],
	'p' => [15],
	'q' => [16],
	'r' => [17],
	's' => [18],
	't' => [8,19],
	'u' => [20],
	'v' => [21],
	'w' => [22],
	'x' => [23,24],
	'y' => [25],
	'z' => [26],
	"'" => [23]
}

def word_to_strokes(s)
	a = []
	s.length.times { |i|
		unless x = LETTER[s[i..i]]
			raise "Invalid character in string: \"#{s}\""
		end
		a += x
	}
	a
end

def process(infile, outfile, trainfile)
	idx = Hash.new
	words = infile.read.split(/\s+/)
	strokes = words.map { |s| word_to_strokes(s) }
	outfile.print "#{words.size} #{STROKES}\n\n"
	words.each_index { |i|
		outfile.print "#{words[i]} #{strokes[i].size}\n"
		outfile.print(strokes[i].join(' ') + "\n\n")
		idx[words[i]] = i
	}
	reps = 4
	trainfile.puts(LETTER.size*reps)
	LETTER.keys.sort.each { |s|
		unless i = idx[s]
			raise "Letter #{s} not in wordlist"
		end
		reps.times {
			trainfile.puts i
		}
	}
end

unless ARGV.size == 3
	$stderr.puts "Usage: ruby build.rb words def train"
	exit(1)
end

process(File.new(ARGV[0],'r'), File.new(ARGV[1],'w'), File.new(ARGV[2],'w'))

