#ifndef _MATRIX_H
#define _MATRIX_H

#include <stdio.h>

typedef struct {
	int m,n;
	double *x[];
} Matrix;

typedef struct {
	int n;
	double x[];
} Vector;

Matrix *matrix_create(int m, int n);
Vector *vector_create(int n);
void matrix_destroy(Matrix *m);
void vector_destroy(Vector *v);
void vector_copy(Vector *d, Vector *v);
void matrix_copy(Matrix *d, Matrix *m);
void vector_normalize(Vector *v);
void matrix_normalize_rows(Matrix *m);
void matrix_col_from_vector(Matrix *m, int j, Vector *v);
void vector_mul_matrix(Vector *d, Vector *v, Matrix *m);
void vector_mul_each_col(Vector *d, Vector *v, Matrix *m, int j);
void vector_add_col(Vector *d, Vector *v, Matrix *m, int j);
void matrix_mul_vector(Vector *d, Matrix *m, Vector *v);
double vector_sum(Vector *v);
double matrix_sum_col(Matrix *m, int j);
double matrix_sum_row(Matrix *m, int i);
void vector_scale(Vector *v, double k);
void vector_print(FILE *file, Vector *v);
void matrix_print(FILE *file, Matrix *m);

#endif

